// Copyright (c) 2006 Forex Capital Markets
// All rights reserved.

var url = "http://rates.fxcm.com/RatesXML";
var defaultCCY = Array('EURUSD', 'USDJPY');
var news_details_view = "";

var latestTime = "";

var http = null;
var itemHttp = null;

var margin = 10;

var rInterval 		= 5;
var nInterval 		= 120;
var nIntervalCounter 	= nInterval;

var uImage = graphics.loadImage("up.gif");
var dImage = graphics.loadImage("down.gif");

var dColor = "#CC0000";
var uColor = "#009900";
var nColor = "#232323";
var hColor = "#0047B9";

var dataMap = {};

view.caption = strTitle;

contentArea.contentFlags = gddContentFlagHaveDetails;

pluginHelper.onAddCustomMenuItems = AddCustomMenuItems; 
pluginHelper.onShowOptionsDlg = ShowOptionsDlg;

loadOptions();
refreshDisplay();

setInterval(OnTimer, 1000 * rInterval);
OnTimer();    // update with first set of items

function AddCustomMenuItems(menu) {
	menu.AddItem(strMenuDisclaimerText, 	0, goToDisclaimer);
  	menu.AddItem(strMenuFXCMTRText, 	0, goToFXCMTR);  
	menu.AddItem(strMenuGoCurrencyText, 	0, goToGoCurrency);
}

function goToDisclaimer() {
	showPage('http://www.fxcm.com/risk-warning.jsp');
}

function goToFXCMTR() {
	showPage('http://www.fxcmtr.com');
}

function goToGoCurrency() {
	showPage('http://www.gocurrency.com');
}

function loadOptions() {
	if (options.GetValue("CCY") == "") {
		options.PutValue("CCY", defaultCCY.toString());
	}
}

function refreshDisplay() {

	contentArea.removeAllContentItems();
        
	var ccyS = GetCCY();	
	var item = null;
	
	item = new ContentItem();
	item.flags = gddContentItemFlagNoRemove;
	item.heading = "Currency Trading News by DailyFX";
	item.onDrawItem = drawDailyFXItem;
	item.open_command = "http://www.dailyfx.com";
	item.onDetailsView = OnNewsDetailsView;
	contentArea.addContentItem(item, gddItemDisplayInSidebar);
	
	for(var i= ccyS.length - 1; i >= 0; i--) {
	
		item = new ContentItem();		
		
		item.heading = ccyS[i];
		//item.snippet = ccyS[i] + "Chart";     // to show in details view
							          	
		item.open_command = "http://www.dailyfx.com/charts/Chart.html?symbol=" + ccyS[i].substring(0, 3) + "/" + ccyS[i].substring(3, 6);				
		item.onDrawItem = DrawItem;
		item.onDetailsView = OnDetailsView;
		contentArea.addContentItem(item, gddItemDisplayInSidebar);
	}
	
	item = new ContentItem();	
	item.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
	item.onDrawItem = drawHeaderItem;
	contentArea.addContentItem(item, gddItemDisplayInSidebar);	
}


function drawHeaderItem(item, target, graphics, x, y, width, height) {

	graphics.DrawText(margin + x, y, width, height, strContentCCYText, hColor, 
		gddTextFlagVCenter, gddFontBold);
    
	graphics.DrawText(margin + x + 50, y, width, height, strContentBidText, hColor, 
		gddTextFlagVCenter, gddFontBold);

	graphics.DrawText(margin + x + 105, y, width, height, strContentAskText, hColor, 
		gddTextFlagVCenter, gddFontBold);

	graphics.DrawText(margin + x + 150, y, width, height, strContentLastText, hColor, 
		gddTextFlagVCenter, gddFontBold);   
}


function drawDailyFXItem(item, target, graphics, x, y, width, height) {
	
	//graphics.DrawText(margin + x, y, width, height, "Currency Trading News by DailyFX", "#FF9900", 
	graphics.DrawText(margin + x, y, width, height, strContentCurrencyNewsText, "#FF9900", 
		gddTextFlagVCenter, gddFontBold);
    
	graphics.DrawText(margin + x + 10, y + 15, width, height, "latest @ " + latestTime, "#898989", 
		gddTextFlagVCenter, gddFontNormal);
}


function GetCCY() {
	
	var arr = new Array();

	if (options.GetValue("CCY") != null) {
		var temp = options.getValue("CCY");	
		arr = temp.split(',');
	}
	
	return arr;
}

function PutCCY(ccyS) {
	options.PutValue("CCY", ccyS.toString());
}

function getAvailableCCY() {
	
	var temp = "";
		
	if (options.GetValue("CCY") != null) {
		temp = options.getValue("CCY");		
	}
	
	var arr = new Array();
	
	for (i in dataMap) { 
		if(temp.indexOf(i) == -1) { arr.push(i); }
	}
	
	return arr;
}


function OnTimer() {
	
	getRates();
  	
  	if(nIntervalCounter == nInterval) {
		getNews();
  		nIntervalCounter = 0;
  	} else {
  		nIntervalCounter += rInterval;
  	}
}


//---- Functions to manage the options dialog
function ShowOptionsDlg(wnd) {
  
  //wnd.AddControl(gddWndCtrlClassLabel, 0, "", strOptionsDlgLabel1Text, 25, 5, 100, 25);
  wnd.AddControl(gddWndCtrlClassList, 0, "a_symbols_list", getAvailableCCY(), 10, 20, 100, 160);
  wnd.AddControl(gddWndCtrlClassList, 0, "url_list", GetCCY(), 200, 20, 100, 160);
  
  var add_btn = wnd.AddControl(gddWndCtrlClassButton, 0, "",
    strOptionsDlgAddButtonText, 120, 25, 70, 25);
  
  var remove_btn = wnd.AddControl(gddWndCtrlClassButton, 0, "",
    strOptionsDlgRemoveButtonText, 120, 55, 70, 25);
    
	var up_btn = wnd.AddControl(gddWndCtrlClassButton, 0, "",
		strOptionsDlgUpButtonText, 120, 110, 70, 25);
    
	var down_btn = wnd.AddControl(gddWndCtrlClassButton, 0, "",
    		strOptionsDlgDownButtonText, 120, 140, 70, 25);

  // handlers
  wnd.onClose = OptionsDlgClosed;
  add_btn.onClicked = AddButtonClicked;
  remove_btn.onClicked = RemoveButtonClicked;
  
  up_btn.onClicked = UpButtonClicked;
  down_btn.onClicked = DownButtonClicked;

}

function UpButtonClicked(wnd, ctrl) {
  
  
    var list = wnd.GetControl("url_list");
    var symbol_to_move = list.value;
    var symbols = list.text.toArray();
    var i;
    
    for(i = 0; i < symbols.length; i++) {
    
    	if(symbols[i] == symbol_to_move) {    	    	
	    	break;
    	}
    }
    
    if(i != 0) {
    
    	symbols.splice(i - 1, 0, symbols[i]);    
    	symbols.splice(i + 1, 1);
    	
    	list.text = symbols;
    	list.value = symbols[i-1];
    }
    
}


function DownButtonClicked(wnd, ctrl) {
  
    var list = wnd.GetControl("url_list");
    var symbol_to_move = list.value;
    var symbols = list.text.toArray();
    var i;
    
    for(i = 0; i < symbols.length; i++) {
    
    	if(symbols[i] == symbol_to_move) {    	    	
		break;
    	} 
    }
    
    if(i != symbols.length - 1) {
    
    	symbols.splice(i + 2, 0, symbols[i]);    
    	symbols.splice(i, 1);
    	
    	list.text = symbols;
    	list.value = symbols[i+1];
    }
    
}

function AddButtonClicked(wnd, ctrl) {
  
  var list = wnd.GetControl("a_symbols_list");
  var symbol_to_add = list.value;
  
  if(symbol_to_add != "") {
  	var symbols = list.text.toArray();
  
  	for(i in symbols) {
  		if(symbols[i] == symbol_to_add) {
  			symbols.splice(i, 1);	
  		}
  	}
  
  	list.text = symbols;
  
  	list = wnd.GetControl("url_list");
  	symbols = list.text.toArray();
  	symbols.push(symbol_to_add);
  	  
  	list.text = symbols;
  }  
}


function RemoveButtonClicked(wnd, ctrl) {
  
  var list = wnd.GetControl("url_list");
    var symbol_to_add = list.value;
    
    var symbols = list.text.toArray();
    
    if(symbol_to_add != "" && symbols.length > 1) {
    	
    	for(i in symbols) {
    		if(symbols[i] == symbol_to_add) {
    			symbols.splice(i, 1);	
    		}
    	}
    
    	list.text = symbols;
    
    	list = wnd.GetControl("a_symbols_list");
    	symbols = list.text.toArray();
    	symbols.push(symbol_to_add);
      
	list.text = symbols;
	}
}


function OptionsDlgClosed(wnd, code) {
  
  if (code == gddIdOK) {
    
    var list = wnd.GetControl("url_list");
   
    var ccyS;
    
    if (list.text == null)
      ccyS = new Array();
    else
      ccyS = new VBArray(list.text).toArray();
      
    PutCCY(ccyS);
        
    refreshDisplay();  
  }
}


function getRates() {
      
  	http = false;
  
  	try {
  	  	http = new XMLHttpRequest();
  	} catch(e) {
  		http = false;
  	}
  
	if(http) {  
		http.onreadystatechange = OnData;
		http.open("GET", url + "?noCache=" + Math.random(), true);
		//http.open("Get", url, true);
		http.send();
	}	
}

function getNews() {

	itemHttp = false;

	try {
		itemHttp = new XMLHttpRequest();
	} catch(e) {
		itemHttp = false;
	}

	if(itemHttp) {
		itemHttp.onreadystatechange = OnReceivedSnippet;
		itemHttp.open("GET", "http://www.dailyfx.com/feeds/rss.xml"+ "?noCache=" + Math.random(), true);
		itemHttp.send();	    
	}
}


function OnData() {
    
    if (http != null && http.readyState == 4 && http.status == 200) { // completed?
   
      // parse the xml data received
      var doc = new DOMDocument();
      doc.loadXML(http.responseText);

      // read the word title, description and link from the xml
      var symbol, bid, ask, link, direction, last;
      var elems = doc.getElementsByTagName("Rate");
      
      
      for(var i=0; i < elems.length; i++) {
            
      	symbol = elems[i].attributes.getNamedItem('Symbol').value;
      	
      	bid = elems[i].getElementsByTagName('Bid')[0].firstChild.nodeValue;
      	ask = elems[i].getElementsByTagName('Ask')[0].firstChild.nodeValue;
      	direction = elems[i].getElementsByTagName('Direction')[0].firstChild.nodeValue;
      	last = elems[i].getElementsByTagName('Last')[0].firstChild.nodeValue;
      	high = elems[i].getElementsByTagName('High')[0].firstChild.nodeValue;
      	low = elems[i].getElementsByTagName('Low')[0].firstChild.nodeValue;
      	
      	var rowMap 	= {};
      	
      	rowMap['Direction'] 	= direction;
      	rowMap['Bid'] 		= bid;
      	rowMap['Ask'] 		= ask;
      	rowMap['High'] 		= high;
      	rowMap['Low']		= low;
      	rowMap['Last']		= last;
      	
      	dataMap[symbol] = rowMap;
      	    
	}
	    
      http = null;  // free the http object
    }
}

function OnDetailsView(item) {
	
	var item_details_view = " ";
	var control = new DetailsView();
	
	if(dataMap[item.heading] != null) {
	
    		var row = dataMap[item.heading];
    					
		item_details_view += "<html><head><link href='http://www.dailyfx.com/export/sites/dailyfx/css/template_css.css' rel='stylesheet' type='text/css' /></head><body>";
		item_details_view += "<table style='border: 1px solid #787878;' width=180><tr bgcolor='#AAAAAA' align='center'><td bgcolor='#386999'><B><font color='#FFFFFF'>"+item.heading+"</FONT></B></td><td>"+row['Last']+"</td></tr>";
		item_details_view += "<tr bgcolor='#DBDBDB' align='center'><td>Bid</td><td>Ask</td></tr>";
		item_details_view += "<tr bgcolor='#FFFFFF' align='center'><td>"+row['Bid']+"</td><td>"+row['Ask']+"</td></tr>";
		item_details_view += "<tr bgcolor='#DBDBDB'  align='center'><td>Low: "+row['Low']+"</td><td>High: "+row['High']+"</td></tr></table>";
				
		item_details_view += "</body></html>";
	}
	
	
	control.SetContent("Click above for real-time chart", Date.NOW, item_details_view, true, item.layout);
	control.html_content = true;
	  
	var details = new Object();
	details.details_control = control;
	        
	return details;
}

function OnNewsDetailsView(item) {
  
	var control = new DetailsView();
	//var tm = new Date();
	control.SetContent("www.dailyfx.com", Date.NOW, news_details_view,
		true, item.layout);
	control.html_content = true;
  
	var details = new Object();
	details.details_control = control;
        
	return details;
}

function OnReceivedSnippet() {
	    
	if (itemHttp != null && itemHttp.readyState == 4 && itemHttp.status == 200) { // completed?
	      
	news_details_view = "<html><head><link href='http://www.dailyfx.com/export/sites/dailyfx/css/template_css.css' rel='stylesheet' type='text/css' /></head><body>";
	      
	var doc = new DOMDocument();
	doc.loadXML(itemHttp.responseText);
	 
	var elems = doc.getElementsByTagName("item");
	 
	var title, link, pubDate;
	
		for(i=0; i < elems.length; i++) {
		                  
			title =  elems[i].getElementsByTagName('title')[0].firstChild.nodeValue;	           	
	            	link = elems[i].getElementsByTagName('link')[0].firstChild.nodeValue;
	            	pubDate = elems[i].getElementsByTagName('pubDate')[0].firstChild.nodeValue;
	            	//desc = elems[i].getElementsByTagName('description')[0].firstChild.nodeValue;
	        		
			if(i == 0) {
				latestTime = pubDate;
	       		}
	       	    	
			news_details_view += "<h3><A HREF=" + link + ">" + title + "</A></h3><h4>" + pubDate + "</h4><BR/>";
		}	    
	   
		news_details_view += "</body></html>";
	      	itemHttp = null;  // free the http object
	}
}

function DrawItem(item, target, graphics, x, y, width, height) {

  
	graphics.DrawText(margin+x, y, width, height, item.heading, "#121212", 
	    	gddTextFlagVCenter, gddFontNormal);
        
    if(dataMap[item.heading] != null) {
    
    	var row = dataMap[item.heading];
    	
    	if(row['Direction'] == 1) {
    	
    		graphics.DrawText(margin+x+50, y, width, height, row['Bid'], uColor, 
			gddTextFlagVCenter, gddFontNormal);
		
		graphics.DrawImage(margin+x+90, y+5, 9, 6, uImage, 100);
	    	
		graphics.DrawText(margin+x+105, y, width, height, row['Ask'], uColor, 
    			gddTextFlagVCenter, gddFontNormal);
    	
    	} else if(row['Direction'] == -1) {
    	
		graphics.DrawText(margin+x+50, y, width, height, row['Bid'], dColor, 
			gddTextFlagVCenter, gddFontNormal);
		
		graphics.DrawImage(margin+x+90, y+5, 9, 6, dImage, 100);
			    	
		graphics.DrawText(margin+x+105, y, width, height, row['Ask'], dColor, 
    			gddTextFlagVCenter, gddFontNormal);
    	
    	} else {
    	
    		graphics.DrawText(margin+x+50, y, width, height, row['Bid'], nColor, 
			gddTextFlagVCenter, gddFontNormal);
				    	
		graphics.DrawText(margin+x+105, y, width, height, row['Ask'], nColor, 
			gddTextFlagVCenter, gddFontNormal);
    	}
    		
    		graphics.DrawText(margin+x+150, y, width, height, row['Last'], "#232323", 
    			gddTextFlagVCenter, gddFontNormal);
    	    
    } else {
    		graphics.DrawText(margin+x+50, y, width, height, 'loading...', "#ABABAB", 
    			gddTextFlagVCenter, gddFontNormal);
    }    
}

function showPage(url) {
  var wshShell = new ActiveXObject("WScript.Shell");
  wshShell.run(url);
  wshShell = null;
}